<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Labresultmapping;

/**
 * LabresultmappingSearch represents the model behind the search form about `app\models\Labresultmapping`.
 */
class LabresultmappingSearch extends Labresultmapping
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['lab_result_mapng_id', 'create_time', 'create_user', 'update_time', 'update_user', 'record_date'], 'integer'],
            [['lab_result_mapng_test', 'lab_result_mapng_result', 'status'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Labresultmapping::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'lab_result_mapng_id' => $this->lab_result_mapng_id,
            'create_time' => $this->create_time,
            'create_user' => $this->create_user,
            'update_time' => $this->update_time,
            'update_user' => $this->update_user,
            'record_date' => $this->record_date,
        ]);

        $query->andFilterWhere(['like', 'lab_result_mapng_test', $this->lab_result_mapng_test])
            ->andFilterWhere(['like', 'lab_result_mapng_result', $this->lab_result_mapng_result])
            ->andFilterWhere(['like', 'status', $this->status]);

        $query->addGroupBy(['lab_result_mapng_test']);

        return $dataProvider;
    }
}
